<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" 
			   creationComplete="creationCompleteHandler(event)" 
			   title="Pesquisa de UF" 
			   xmlns:visual="br.com.desenv.framework.component.visual.*"
			   maxWidth="1200" maxHeight="700" 
			    xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="UfSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.Uf;

			
			[Bindable]
			public var listaUf: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			

			
			private var ufComponenteDetalhe: UfComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): Uf
			{
				var ufFiltro: Uf = new Uf();
				
				ufFiltro.sigla = ignTextInputSiglaPesquisa.text == ""?null:ignTextInputSiglaPesquisa.text;
				ufFiltro.nome = ignTextInputNomePesquisa.text == ""?null:ignTextInputNomePesquisa.text;
				ufFiltro.codEstadoIBGE = ignTextInputCodEstadoIBGEPesquisa.text == ""?null:ignTextInputCodEstadoIBGEPesquisa.text;
				return ufFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	
				
				
				var ufFiltro: Uf = new Uf();
				remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, ufFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaUf: Page = event.result as Page;
				pageNumber = paginaUf.pageNumber;
				totalRecords = paginaUf.totalRecords;
				lastPage = paginaUf.lastPage();
				listaUf = paginaUf.recordList;
				labelPaginaAtual.text = "" + paginaUf.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaUf.totalRecords;
			}

// CARREGANDO COMBOS			

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	
					remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var ufComponenteCadastro: UfComponenteCadastro = new UfComponenteCadastro();
				ufComponenteCadastro.uf = new Uf(); 
				ufComponenteCadastro.addEventListener("UfIncluidoEvent", atualizarListaUfPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(ufComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(ufComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var ufSelecionado: Uf = datagridListaUf.selectedItem as Uf;
				this.dispatchEvent(new ResultEvent("UfSelecionadoEvent",false, true, ufSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaUf_doubleClickHandler(event:MouseEvent):void
			{
				ufComponenteDetalhe = new UfComponenteDetalhe();
				ufComponenteDetalhe.uf = datagridListaUf.selectedItem as Uf;
				ufComponenteDetalhe.addEventListener("UfExcluidoEvent", atualizarListaUfPorExclusaoResultHandler);
				ufComponenteDetalhe.addEventListener("UfAtualizadoEvent", atualizarListaUfPorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(ufComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(ufComponenteDetalhe);
			}
			
			
			private function atualizarListaUfPorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	
				remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaUfPorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	
				remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaUfPorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	
				remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	
				remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectUf: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("ufService", listarResultHandler);	
				remoteObjectUf.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
			
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Sigla:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoSiglaPesquisa" styleName="labelValidacao" text="{ignTextInputSiglaPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputSiglaPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Nome:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNomePesquisa" styleName="labelValidacao" text="{ignTextInputNomePesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputNomePesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>


		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Código IBGE:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoCodEstadoIBGEPesquisa" styleName="labelValidacao" text="{ignTextInputCodEstadoIBGEPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputCodEstadoIBGEPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaUf"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaUf}" doubleClick="datagridListaUf_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="sigla" headerText="Sigla" resizable="true"/>
						<mx:DataGridColumn dataField="nome" headerText="Nome" resizable="true"/>
						<mx:DataGridColumn dataField="codEstadoIBGE" headerText="Código IBGE" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
